Option Explicit

Global engineInitialized As Integer

Sub showDBError (errCode%)

Dim errCode2 As Integer
Dim errMsg As String * 128
Dim userMsg$

' get the error code from the database
errCode2 = DbiGetErrorString(errCode, errMsg)

' make the error message the user sees
userMsg = "Error code: " + Str$(errCode) + Chr$(13) + errMsg

'Show the error
MsgBox userMsg, 16, "Database error"

End Sub

Sub showRecords (db As ggsConnection, grdSQL As SSView, ByVal nFields As Integer)

Dim count As Integer
Dim gridString As String
Dim curRow As Integer
Dim errCode As Integer
Dim fldName As String * 81

curRow = 1

On Error GoTo showRecordsErr

   ' get all the field names and put in the header
   For count = 1 To nFields
      getFieldName db, count, fldName
      errCode = SSSetColText(grdSQL.SS, count, strip(fldName))
   Next

   Do
      grdSQL.MaxRow = curRow
      gridString = ""
      
      For count = 1 To nFields
         getField db, count
         errCode = SSSetTextRC(grdSQL.SS, curRow, count, strip(db.dest))
      Next
      
'      grdSQL.AddItem gridString, curRow
      nextRecord db
      curRow = curRow + 1
   Loop While db.notifyMsg = 0

   errCode = SSSetColWidthAuto(grdSQL.SS, -1, -1, 1, 1, True)

showRecords1:
   Exit Sub

showRecordsErr:
   showDBError db.errCode
   Resume showRecords1

End Sub

Function strip (source As String)

Dim dest As String
Dim strLen As Integer

strLen = InStr(source, Chr$(0))
If strLen > 0 Then
   dest = Left$(source, strLen - 1)
Else
   dest = ""
End If

strip = dest

End Function

